/* Herramientas para el trabajo con matrices */

#include <stdlib.h>
#include <stdio.h>

typedef float elem;
typedef elem *vector;
typedef vector *matriz;

#ifndef Err
#define Err(msg)	{ \
                          printf("Error:%s.",msg);\
                          exit(-1);\
                        }
#endif

vector reserva_vector(unsigned n)
/* Reserva memoria para un vector */
{
  vector v = (vector) calloc(n,sizeof(elem));
  if ((v==NULL) && (n != 0))
    Err("Falta memoria");
  return (v);
}


matriz reserva_matriz(unsigned m, unsigned n)
/* Reserva memoria para una matriz */
{
  unsigned i;
  matriz mat = (matriz) calloc(m,sizeof(vector));

  if ((mat==NULL) && (m != 0))
    Err("Falta memoria");
  for (i=0; i<m; i++)
    mat[i]=reserva_vector(n);
  return (mat);
}


void libera_vector( vector v)
{
  free(v);
}


void libera_matriz (unsigned m, matriz mat)
{
  unsigned i;
  for (i=0; i<m; i++)
    libera_vector(mat[i]);
  free(mat);
}


/*lee_matriz devuelve el numero de filas que leyo realmente */
unsigned lee_matriz (FILE *fd, unsigned m, unsigned n, matriz mat)
/* Lee desde el disco una matriz de m*n elementos (n col y m fil) */
{
  int dev;
  unsigned i,j;
  vector indi;

  for (i=0; i<m; ) {
    indi=mat[i++];
    for (j=n; j--;)
      if((dev=fscanf(fd,"%f",indi++))!=1)
	if (dev==EOF)
	  return(i-1);
	else
          Err("Tipo erroneo de fichero de entrada");
  }
  return(m);
}


void escribe_matriz (FILE *fd, unsigned m, unsigned n, matriz mat)
/* Lee desde el disco una matriz de m*n elementos (n col y m fil) */
{
  unsigned i,j;
  vector indi;

  for (i=0; i<m; ) {
    indi=mat[i++];
    for (j=n; j--;)
      if(fprintf(fd,"%f\t",(*indi++))==EOF)
        Err("No se pudo escribir fichero");
    if(fprintf(fd,"\n")==EOF)
        Err("No se pudo escribir fichero");
  }
}

